import java.awt.Graphics.*;
import java.awt.Image.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.sql.*;
import java.io.*;
import java.util.*;

import oracle.jdbc.driver.*;

public class DisplayImage2 extends java.applet.Applet
implements ActionListener
{
MediaTracker theTracker = null;
String blob_id;
Image theImage;
Graphics theGraphic;

Button show_button;
Button cancel_button;
Button execute_button;

Canvas blobCanvas = new drawCanvas();
TextField theStatus = new TextField(64);
TextField getblobid = new TextField(4);
TextArea output = new TextArea();
Font outputFont = new Font(Courier, Font.PLAIN, 12);

static String inc_value;

Frame imageFrame = new Frame(Blob Retrieval Window);
Panel queryPanel = new Panel ();
Panel statusPanel = new Panel ();
Panel buttonPanel = new Panel ();
Panel blobPanel = new Panel();

public void init( )
{
queryPanel.setLayout (new BorderLayout ( ));
execute_button = new Button (Get BLOBs);
execute_button.addActionListener(this);
queryPanel.add (North, execute_button);
output = new TextArea (22, 40);
output.setFont(outputFont);
queryPanel.add (Center, output);

buttonPanel.setLayout (new GridLayout (1,3));
show_button = new Button (Show);
show_button.addActionListener(this);
buttonPanel.add(North, show_button);
cancel_button = new Button (Cancel);
cancel_button.addActionListener(this);
buttonPanel.add(North, cancel_button);
buttonPanel.add(West, new Label(Enter Blob ID:, Label.RIGHT));
buttonPanel.add(Center, getblobid);

blobPanel.setLayout (new BorderLayout());
blobPanel.add(East, blobCanvas);
blobPanel.add(North, buttonPanel);
this.validate();

statusPanel.setLayout (new BorderLayout ( ));
statusPanel.add(South, theStatus);

theStatus.setEditable(false);
getblobid.setEditable(true);

imageFrame.setLayout (new BorderLayout( ));
imageFrame.add(West, queryPanel);
imageFrame.add(South, statusPanel);
imageFrame.add(East, blobPanel);
imageFrame.pack();
imageFrame.setVisible(true);
theTracker = new MediaTracker(this);
}

public void actionPerformed(ActionEvent event)
{

Object source = event.getSource();

if (source == execute_button)
{
try
{
output.setText (null);

Class.forName (oracle.jdbc.driver.OracleDriver);

Connection conn =
DriverManager.getConnection (jdbc:oracle:oci8:TEST,
graphics_dba, graphics1);

Statement stmt = conn.createStatement ();

output.append(Blobs Available to View + \n);
ResultSet rset = stmt.executeQuery (SELECT rpad(to_char(graphic_id),5)||
': '||rpad(graphic_desc,30)||': '||rpad(graphic_type,10)
FROM internal_graphics order by graphic_id);

while (rset.next ()) output.append(rset.getString (1) + \n);
}
catch (Exception e)
{
handleError(e);
}
getblobid.requestFocus();
}


if (source == show_button)
{
blob_id = getblobid.getText();
theStatus.setText(Looking For BLOB : + blob_id);

try
{
theStatus.setText(Logging On);
Class.forName (oracle.jdbc.driver.OracleDriver);

Connection conn =
DriverManager.getConnection (jdbc:oracle:oci8:TEST,
graphics_dba, graphics1);
theStatus.setText(Connection Established);

Statement stmt = conn.createStatement ();

ResultSet inc = stmt.executeQuery (
select to_char(image_seq.nextval) from dual);
if (inc.next ())
inc_value = inc.getString (1);

theStatus.setText(Fetching BLOB : + blob_id);
ResultSet rset = stmt.executeQuery (
select graphic_blob from internal_graphics where
graphic_id= + blob_id);

if (rset.next ())
{
OracleBlob blob = ((OracleResultSet)rset).getBlob (1);
theStatus.setText(Placing Blob in Temp File);
dumpBlob(conn,blob);
theStatus.setText(Showing Image);
getblobid.setText();
theImage = getImage(getCodeBase(),images/theImage + inc_value + .gif);
theTracker = new MediaTracker(this);
theTracker.addImage(theImage, 0);
try {
theTracker.waitForID(0);
}
catch (InterruptedException e) { }
blobPanel.setVisible(false);
repaint();
blobPanel.setVisible(true);
getblobid.requestFocus();
}
}
catch (ClassNotFoundException c)
{
handleError(c);
}
catch (SQLException sql)
{
handleError(sql);
}
catch (Exception s)
{
handleError(s);
}
}

if (source == cancel_button) System.exit(0);
}

class drawCanvas extends Canvas
{
int iWidth = 480;
int iHeight = 500;
public void paint(Graphics theGraphic)
{
Dimension minSize = getPreferredSize();
if (theTracker != null)
{
if (theTracker.isErrorAny())
{
theGraphic.setColor(Color.red);
theGraphic.drawString(Image Error,60,10);
return;
}
if (theTracker.checkAll(true))
{
iWidth = theImage.getWidth(this);
iHeight = theImage.getHeight(this);
if (iHeight>480)
{
iWidth=iWidth/2;
iHeight=iHeight/2;
}
if (iWidth>500)
{
iWidth=iWidth/2;
iHeight=iHeight/2;
}
int xpos = 60;
minSize = getPreferredSize();
theGraphic.drawImage(theImage, xpos, 20, iWidth, iHeight, this);
}
else
{
theGraphic.setColor(Color.green);
theGraphic.drawString(Image loading ., 60,10);
repaint(100);
}
}
}
public Dimension getPreferredSize()
{
/*System.out.println(iWidth +  x  + iHeight);*/
return new Dimension (iWidth,iHeight);
}
}

public void destroy()
{
theGraphic.dispose();
System.gc();
}

public void handleError(Throwable t)
{
theStatus.setText(Error:  + t.getMessage( ));
t.printStackTrace( );
}

static void dumpBlob (Connection conn, OracleBlob blob)
throws Exception
{
OracleCallableStatement cstmt1 =
(OracleCallableStatement)
conn.prepareCall (begin ? := dbms_lob.getLength (?); end;);
OracleCallableStatement cstmt2 =
(OracleCallableStatement)
conn.prepareCall (begin dbms_lob.read (?, ?, ?, ?); end;);
cstmt1.registerOutParameter (1, Types.NUMERIC);
cstmt1.setBlob (2, blob);
cstmt1.execute ();
long length = cstmt1.getLong (1);
long i=0;
int chunk=100;
FileOutputStream file = new FileOutputStream (
images/theImage + inc_value+ .gif);
while (i < length)
{
cstmt2.setBlob (1, blob);
cstmt2.setLong (2, chunk);
cstmt2.registerOutParameter (2, Types.NUMERIC);
cstmt2.setLong (3, i+1);
cstmt2.registerOutParameter (4, Types.VARBINARY);
cstmt2.execute ();
long read_this_time = cstmt2.getLong (2);
byte [] bytes_this_time = cstmt2.getBytes (4);
{

file.write (bytes_this_time);
i += read_this_time;
/* System.out.print (Read  + i +  bytes of  + length + \n);*/
if ((i + read_this_time)>length) chunk = (int) (length-i);
}
}
file.close();
cstmt1.close ();
cstmt2.close ();
}
}
